; sortieren-durch-einfuegen-schrittweise.scm

; globale Variable nur zur Vereinfachung
(define
  liste
  '(11 -2 3 43 33 5.5 3 7))

;;; ----- 1 -----
; Kopf der Funktion
(define
  (sortiere liste)
  'undefiniert)

; Test:
(sortiere liste)

;;; ----- 2 -----
; Die Liste ist leer.
(define
  (sortiere liste)
  (cond
    ((null? liste)
     liste)
    (else
     'undefiniert)))

; Test:
(sortiere '())
(sortiere liste)

;;; ----- 3 -----
; Die Liste ist nicht leer.
; Problem lösen: Wo bleibe ich mit den sortierten Elementen?
; Problemlösung weiterreichen an Hilfsfunktion sortiere-hilfe
; mit den Parametern sortierte und unsortierte.
(define
  (sortiere-hilfe unsortierte sortierte)
  'undefiniert)

(define
  (sortiere liste)
  (cond
    ((null? liste)
     liste)
    (else
     (sortiere-hilfe '() liste))))

; Test:
(sortiere '())
(sortiere liste)

;;; ----- 4 -----
; sortiere-hilfe entwickeln
; unsortierte ist leer -> fertig!
(define
  (sortiere-hilfe unsortierte sortierte)
  (cond
    ((null? unsortierte)
     sortierte)
    (else
     'undefiniert)))

(define
  (sortiere liste)
  (cond
    ((null? liste)
     liste)
    (else
     (sortiere-hilfe '() liste))))

; Test:
(sortiere '())
(sortiere liste)

;;; ----- 5 -----
; sortiere-hilfe entwickeln
; unsortierte ist nicht leer.
; Diese Funktion muss weiter arbeiten, allerdings mit
; - der um das erste Element verkürzten Liste unsortierte und
; - dem ersten Element von unsortierte in die sortierte einsortiert.
; Wer bringt es an die richtige Stelle?
; Problemlösung weiterreichen an Hilfsfunktion einfuegen
; mit den Parametern element und sortierte.
(define
  (einfuegen element sortierte)
  'undefiniert)

(define
  (sortiere-hilfe unsortierte sortierte)
  (cond
    ((null? unsortierte)
     sortierte)
    (else
     (sortiere-hilfe
      (rest unsortierte)
      (einfuegen (first unsortierte) sortierte)))))

(define
  (sortiere liste)
  (cond
    ((null? liste)
     liste)
    (else
     (sortiere-hilfe '() liste))))

; Test:
(sortiere '())
(sortiere liste)

;;; ----- 6 -----
; einfuegen entwickeln
; sortierte ist leer.
; Liste mit element zurückgeben.
(define
  (einfuegen element sortierte)
  (cond
    ((null? sortierte)
     (list element))
    (else
     'undefiniert)))

(define
  (sortiere-hilfe unsortierte sortierte)
  (cond
    ((null? unsortierte)
     sortierte)
    (else
     (sortiere-hilfe
      (rest unsortierte)
      (einfuegen (first unsortierte) sortierte)))))

(define
  (sortiere liste)
  (cond
    ((null? liste)
     liste)
    (else
     (sortiere-hilfe '() liste))))

; Test:
(sortiere '())
(sortiere liste)

;;; ----- 7 -----
; einfuegen entwickeln
; sortierte ist nicht leer und element kommt vor das erste Element von sortierte.
; Liste mit element vor sortierte zurückgeben.
; Wer entscheidet was vor ist?
; Problemlösung weiterreichen an Hilfsfunktion vor?
; mit den Parametern erstes und zweites.
(define
  (vor? erstes zweites)
  ; An dieser Stelle kommt zum erstenmal eine Kontext-abhängige Entscheidung:
  (< erstes zweites))

(define
  (einfuegen element sortierte)
  (cond
    ((null? sortierte)
     (list element))
    ((vor? element (first sortierte))
     (cons element sortierte))
    (else
     'undefiniert)))

(define
  (sortiere-hilfe unsortierte sortierte)
  (cond
    ((null? unsortierte)
     sortierte)
    (else
     (sortiere-hilfe
      (rest unsortierte)
      (einfuegen (first unsortierte) sortierte)))))

(define
  (sortiere liste)
  (cond
    ((null? liste)
     liste)
    (else
     (sortiere-hilfe '() liste))))

; Test:
(sortiere '())
(sortiere liste)


;;; ----- Hilfsfunktion vor? -----
(define
  (vor? erstes zweites)
  ; Kontext-abhängige Entscheidung:
  (< erstes zweites))

;;; ----- 8 -----
; einfuegen entwickeln
; sortierte ist nicht leer und element kommt >>>nicht<<< vor
; das erste Element von sortierte.
; Das erste Element von sortierte muss vor das Ergebnis des Einfuegens
; von element in den Rest von sortierte gebracht werden.
(define
  (einfuegen element sortierte)
  ;(bkpt element sortierte)
  (cond
    ((null? sortierte)
     (list element))
    ((vor? element (first sortierte))
     (cons element sortierte))
    (else
     (cons (first sortierte) (einfuegen element (rest sortierte))))))

(define
  (sortiere-hilfe unsortierte sortierte)
  ;(bkpt unsortierte sortierte)
  (cond
    ((null? unsortierte)
     sortierte)
    (else
     (sortiere-hilfe
      (rest unsortierte)
      (einfuegen (first unsortierte) sortierte)))))

(define
  (sortiere liste)
  (cond
    ((null? liste)
     liste)
    (else
     (sortiere-hilfe liste '()))))

; Test:
(sortiere '())
(sortiere liste)
